#various "queries" to Wordnet to help the user expand his information retrieval query

import wntools
import wordnet

#notes:
#same meaning = similar
#opposite meaning = antonym
#whole object = a type of meronym
#more general = hypernym
#more specific = hyponym
#parts of object = a type of holonym
#attributes = attribute

def getNounsResponse(word, nouns):
	s = ""
	#return `nouns`

	#for getting info. on which pointer types listbox entries correspond to
	#result = wordnet.N[word][0]
	#for pt in wordnet.POINTER_TYPES:
	#	s = s + `pt` + "=" + `wntools.closure(result, pt)`
	#	s = s + "\n" + ("*" * 80 ) + "\n"
	#return s
	#end of code to get info. on listbox types

	try:
		wordnet.N[word]
	except:
		return "<p>'" + word + "' is not in the dictionary.</p>"

	if type(nouns) == type(""): nouns = [nouns]
	for noun in nouns:
		if noun == "same meaning":
			s = s + "<p><b>Same Meaning:</b></p>"
			i = 1
			for result in wordnet.N[word]:
				s = s + "<p>Sense " + `i` + ": " + `wntools.closure(result, wordnet.SIMILAR)` + "</p>"
				i = i + 1
		elif noun == "opposite meaning":
			s = s + "<p><b>Opposite Meaning:</b></p>"
			i = 1
			for result in wordnet.N[word]:
				closure = wntools.closure(result, wordnet.ANTONYM)
				if len(closure) == 1:
					prefix = "Sorry, no antonyms for "
				else:
					prefix = ""
				s = s + "<p>Sense " + `i` + ": " + prefix + `closure` + "</p>"
				i = i + 1
		elif noun == "whole object":
			s = s + "<p><b>Whole Object:</b></p>"
			i = 1
			for result in wordnet.N[word]:
				closure1 = wntools.closure(result, wordnet.MEMBER_MERONYM)
				closure2 = wntools.closure(result, wordnet.SUBSTANCE_MERONYM)
				closure3 = wntools.closure(result, wordnet.PART_MERONYM)
				if len(closure1) == 1:
					prefix1 = "Sorry, no member meronyms for "
				else:
					prefix1 = ""
				if len(closure2) == 1:
					prefix2 = "Sorry, no substance meronyms for "
				else:
					prefix2 = ""
				if len(closure3) == 1:
					prefix3 = "Sorry, no part meronyms for "
				else:
					prefix3 = ""
				s = s + "<p>Sense " + `i` + ": " + prefix1 + `closure1` + "</p>"
				s = s + "<p>Sense " + `i` + ": " + prefix2 + `closure2` + "</p>"
				s = s + "<p>Sense " + `i` + ": " + prefix3 + `closure3` + "</p>"
				i = i + 1
		elif noun == "more general":
			s = s + "<p><b>More General:</b></p>"
			i = 1
			for result in wordnet.N[word]:
				closure = wntools.closure(result, wordnet.HYPERNYM)
				if len(closure) == 1:
					prefix = "Sorry, no hypernyms for "
				else:
					prefix = ""
				s = s + "<p>Sense " + `i` + ": " + prefix + `closure` + "</p>"
				i = i + 1
		elif noun == "more specific":
			s = s + "<p><b>More Specific:</b></p>"
			i = 1
			for result in wordnet.N[word]:
				closure = wntools.closure(result, wordnet.HYPONYM)
				if len(closure) == 1:
					prefix = "Sorry, no hyponyms for "
				else:
					prefix = ""
				s = s + "<p>Sense " + `i` + ": " + prefix + `closure` + "</p>"
				i = i + 1
		elif noun == "part of object":
			s = s + "<p><b>Parts of Object:</b></p>"
			i = 1
			for result in wordnet.N[word]:
				closure1 = wntools.closure(result, wordnet.MEMBER_HOLONYM)
				closure2 = wntools.closure(result, wordnet.SUBSTANCE_HOLONYM)
				closure3 = wntools.closure(result, wordnet.PART_HOLONYM)
				if len(closure1) == 1:
					prefix1 = "Sorry, no member holonyms for "
				else:
					prefix1 = ""
				if len(closure2) == 1:
					prefix2 = "Sorry, no substance holonyms for "
				else:
					prefix2 = ""
				if len(closure3) == 1:
					prefix3 = "Sorry, no part holonyms for "
				else:
					prefix3 = ""
				s = s + "<p>Sense " + `i` + ": " + prefix1 + `closure1` + "</p>"
				s = s + "<p>Sense " + `i` + ": " + prefix2 + `closure2` + "</p>"
				s = s + "<p>Sense " + `i` + ": " + prefix3 + `closure3` + "</p>"
				i = i + 1
		elif noun == "attribute":
			s = s + "<p><b>Attributes:</b></p>"
			i = 1
			for result in wordnet.N[word]:
				closure = wntools.closure(result, wordnet.ATTRIBUTE)
				if len(closure) == 1:
					prefix = "Sorry, no attributes for "
				else:
					prefix = ""
				s = s + "<p>Sense " + `i` + ": " + prefix + `closure` + "</p>"
				i = i + 1
		elif noun == "example":
			s = s + "<p><b>Example:</b></p>"
			s = s + "<p>" + "Examples have not been implemented yet." + "</p>"
	return s

def getVerbsResponse(word, verbs):
	s = ""
	return s

def getAdjectivesResponse(word, adjectives):
	s = ""
	return s

def getAdverbsResponse(word, adverbs):
	s = ""
	return s

def askWordnet(self, REQUEST):
	word = REQUEST["Word"]
	nouns = REQUEST.get("Nouns", None)
	verbs = REQUEST.get("Verbs", None)
	adjectives = REQUEST.get("Adjectives", None)
	adverbs = REQUEST.get("Adverbs", None)

	beginResponse = "<html><head></head><body><big>"

	if not (nouns or verbs or adjectives or adverbs):
		response = ("</p>Please select type of information you are seeking, "
				+ "such as 'For a Noun, Same Meaning', etc. <br>Multiple selections "
				+ "can be made in multiple listboxes.</p>")
	else:
		nounsResponse = getNounsResponse(word, nouns)
		verbsResponse = getVerbsResponse(word, verbs)
		adjectivesResponse = getAdjectivesResponse(word, adjectives)
		adverbsResponse = getAdverbsResponse(word, adverbs)

	response = nounsResponse + verbsResponse + adjectivesResponse + adverbsResponse

	endResponse = "</big></body></html>"

	return beginResponse + response + endResponse
	#return `REQUEST`
