#A Python Interface to Managing Gigabytes library as released with Greenstone.
#Modified and simplified version of "mgbuild.sh," a csh script (some options removed, etc.).
#
import sys
import os
import glob

#parse the command line args
argvCopy = sys.argv[1:]	#copy but skip Python program's (mgBuild) name

#start of functions to roughly emulate csh commands, etc. Purpose of this is to make the translation
#more straightforward to think about since I don't do much shell script work at all.
def shift():
	global argvCopy
	argvCopy = argvCopy[1:]
	return

def argv():
	global argvCopy
	return argvCopy

def lenArgv():
	global argvCopy
	return len(argvCopy)

def firstArg():
	global argvCopy
	return argvCopy[0]

def set(arg):
	return arg
#end of functions to roughly emulate csh commands, etc.

def main():
	while lenArgv() >= 1:
		if firstArg() == "-b":
			shift()
			if lenArgv() >= 1:
				binDir = set(firstArg())
				shift()
				print "binDir=" + binDir
		elif firstArg() == "-i":
			shift()
			if lenArgv() >= 1:
				inputPath = set(firstArg())
				shift()
				print "inputPath=" + inputPath
		elif firstArg() == "-d":
			shift()
			if lenArgv() >= 1:
				collectionPath = set(firstArg())
				shift()
				print "collectionPath=" + collectionPath
		elif firstArg() == "-n":
			shift()
			if lenArgv() >= 1:
				collectionName = set(firstArg())
				shift()

	try:
		#check for var existence; throw exception if they don't exist
		if binDir == 0 and inputPath == 0 and collectionPath == 0 and collectionName == 0:
			pass
	except:
		print
		print "USAGE:"
		print "\tmgBuilderPy -b binaries-path -i input-path -d collection path -n collection-name"
		print

		sys.exit(1)

	get = set(binDir + "\mg_get")

	input_files = glob.glob(inputPath + "\\*.*")

	print "input_files=" + `input_files`

	#set the stemming method
	#Bit 0 = case folding
	#Bit 1 = S stemer
	stem_method = set(3)

	# If do_indexes == 1 then build collection with full indexes to blocked file
	# overriding stem_method (stem_method will be set to 0)
	# Otherwise don't build with indexes
	do_indexes = set(0)


	# If do_text == 1 then do the text component of building a mg database.
	# Otherwise don't do the text component.
	do_text = set(1)


	# If do_invf == 1 then do the inversion component of building a mg database.
	# Otherwise don't do the inversion component.
	do_invf = set(1)


	# If do_pass1 == 1 then do pass1 of building a mg database.
	# Otherwise don't do pass1.
	do_pass1 = set(1)

	# If do_pass2 == 1 then do pass2 of building a mg database.
	# Otherwise don't do pass2.
	do_pass2 = set(1)


	# $invf_mem specifies the amount of memory to use for the pass2 inversion
	invf_mem = set(32)


	# $num_chunks specifies the number of interium chunks of inverted file that
	# may be written to disc before a merge into the invf file is done
	num_chunks = set(3)

	# $invf_level specifies the level of the inverted file that will be generated.
	invf_level = set(2)


	# If $strip_sgml == 1 then sgml tags are stripped from the inversion phase.
	# Otherwise sgml tags are kept.
	strip_sgml = set(1)


	# $trace specifies the interval between trace entries in Mb.
	# If this is not set no trace entries will be generated.
	trace = set(10)


	# $weight_bits specifies the number of bits of precision bo be given to the
	# approximate weights.
	weight_bits = set(6)


	# $mcd specifies the commandline arguments for the mg_compression_dict program
	#### Note: Set -S so novel words can be encoded, as this will happen if
	#### mgmerge is used.
	mcd = "-S"

	# If do_indexes == 1 then set stem_method = 0
	if do_indexes == 1:
		stem_method = set(0)

	if invf_level == 3:
		collectionName = set(collectionName + "-p")
	print "collectionName=" + collectionName

	# Generate the directory for the collection.
	if not os.path.exists(collectionPath + "\\" + collectionName):
		os.mkdir(collectionPath + "\\" + collectionName)

if __name__ == "__main__":
	main()