#performs search by calling storagerIndexer with query, receiving results of the search, and
#returning them to Zope. Also responds to the user clicking on one of the search URLs. Calls
#storagerIndexer to get contents of URL from the user's database. Returns contents to Zope.

import socket
import time

PORT = 8578			#arbitrary, high number

def writeDebugInfo(msg):
	debugFile = open("c:/debug.txt", "a+")
	debugFile.write(msg)
	debugFile.close()
	return

def tracebackAsString(limit):
	type, value, tb = sys.exc_info()
	aList = traceback.format_exception(type, value, tb, limit)
	formattedString = ""
	for s in aList:
		formattedString = formattedString + s + "\n"
	return formattedString

def getPage(self, REQUEST, AUTHENTICATED_USER):
	#Zope external method
	pageId = REQUEST["pageId"]
	authenticatedUser = `AUTHENTICATED_USER`
	serverName = REQUEST["SERVER_NAME"]
	storageFolder = self.aq_parent["storageFolder"]
	mgDir = self.aq_parent["mgDir"]
	mgCollection = self.aq_parent["mgCollection"]
	thePage = "Error retrieving page."

	try:
		clientsock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
		retrievalRequest = ("retrieve" + "|"
							+ authenticatedUser + "|"
							+ storageFolder + "|"
							+ pageId + "|"
							+ mgDir + "|"
							+ mgCollection)
		clientsock.connect(serverName, PORT)
		clientsock.send(retrievalRequest)
		thePage = clientsock.recv(204800) #200K--is this over some limit/impractical?
		clientsock.close()
	except Exception, data:
		writeDebugInfo("Error retrieving page from storager: " + `data` + "\n")
		try:
			clientsock.close()
		except:
			pass

	return thePage

def search(self, REQUEST, AUTHENTICATED_USER):
	#Zope external method
	query = REQUEST["query"]
	authenticatedUser = `AUTHENTICATED_USER`
	serverName = REQUEST["SERVER_NAME"]
	storageFolder = self.aq_parent["storageFolder"]
	mgDir = self.aq_parent["mgDir"]
	mgCollection = self.aq_parent["mgCollection"]
	queryResults = "Error performing query."

	try:
		clientsock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
		dateAndTime = time.ctime(time.time())
		searchRequest = ("query" + "|"
							+ authenticatedUser + "|"
							+ storageFolder + "|"
							+ query + "|"
							+ mgDir + "|"
							+ mgCollection)
		clientsock.connect(serverName, PORT)
		clientsock.send(searchRequest)
		queryResults = clientsock.recv(204800) #200K
		clientsock.close()
	except Exception, data:
		writeDebugInfo("Error querying storager: " + `data` + "\n")
		try:
			clientsock.close()
		except:
			pass

	return queryResults
